// (C) 1997,   Andreas Hirczy <ahi@sbox.tu-graz.ac.at> 


// Representation of a single particle
class Particle
{
  // Coordinates of particle
  float x, y, z;

  // velocity (1st derivative) of particle
  float dx, dy, dz;

  // accelaration (2nd derivative) of particle
  float ddx, ddy, ddz;
  
public:
  // Static data members determine default and derivation for initial values
  static float x_def, y_def, z_def, dx_def, dy_def, dz_def;
  static float x_dev, y_dev, z_dev, dx_dev, dy_dev, dz_dev;

  // Static data member determines value of a single timestep
  static float time_step;

  // Constructor
  Particle();


  // get values of particle
  float  X() { return  x; };
  float  Y() { return  y; };
  float  Z() { return  z; };
  float dX() { return dx; };
  float dY() { return dy; };
  float dZ() { return dz; };

  // compute next "nr_steps" steps; time base is static data member
  // "time_step" 
  void Next(unsigned int nr_steps=1);
};


#include <ostream.h>
ostream& operator<<(ostream& s, Particle p);
//istream& operator>>(istream& s, Particle p);
